#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASListBuddy : public CWASCommand
{
public:
	CWASListBuddy(CWASActor *pActor);
	~CWASListBuddy(void);

	void ExecuteAsync(void);
    void SetParameter(LPCWSTR strLangCode, int nCacheSerial)
    {
		m_strLangCode = strLangCode;
        m_nCacheSerial = nCacheSerial;
    }
    
private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);
    
protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
    bool m_bAllRecvedList;
	LPCWSTR m_strLangCode;
    int m_nCacheSerial;
	p_buddylist_t m_listAddressPrivate;
	buddylist_t m_listAddress;
};
